<template>
  <div>
    <GI18nCard
      :i18n="i18n"
      :card="card"
      level="third"
      v-bind="$attrs"
      :wiki-entry="wikiEntry"
      :optional="optional"
      @deleteElement="$emit('delete')"
    >
      <template #card-title-append>
        <v-spacer />
        <GDropDownMenu
          i18n="form.addElement"
          :available-elements="availableElements"
          icon="add"
          @addElement="addElement"
        />
      </template>
      <v-row dense>
        <GCol cols="12">
          <GTextField
            v-model="value._attr.refType"
            i18n="dcc.common.attributes.refType"
            attr-ref-type
          />
        </GCol>
        <GCol cols="12">
          <DccLocalizedTextBlock
            v-model="value.referral"
            i18n="dcc.common.hashType.referral"
            validate="required"
            :disabled="disabled"
          />
        </GCol>
        <GCol cols="12">
          <XmlTextField
            v-model="value.referralID"
            i18n="dcc.common.hashType.referralID"
            validate="required"
            :disabled="disabled"
          />
        </GCol>
        <GCol cols="12" md="6">
          <XmlTextField
            v-model="value.procedure"
            i18n="dcc.common.hashType.procedure"
            validate="required"
            :disabled="disabled"
          />
        </GCol>
        <GCol cols="12" md="6">
          <XmlTextField
            v-model="value.value"
            i18n="dcc.common.hashType.value"
            validate="required"
            :disabled="disabled"
          />
        </GCol>
        <GCol cols="12">
          <RichContent
            v-if="value.description"
            v-model="value.description"
            i18n="dcc.common.hashType.description"
            :disabled="disabled"
            optional
            not-in-dialog
            wiki-entry="richContent"
            @delete="deleteRichContent"
          />
        </GCol>
        <GCol cols="12" md="6">
          <XmlCheckbox
            v-model="value.inValidityRange"
            i18n="dcc.common.hashType.inValidityRange"
            :disabled="disabled"
          />
        </GCol>
        <GCol cols="12" md="6">
          <XmlCheckbox
            v-model="value.traceable"
            i18n="dcc.common.hashType.traceable"
            :disabled="disabled"
          />
        </GCol>
      </v-row>
    </GI18nCard>
  </div>
</template>

<script>
import { RichContentType } from "@d-ptb/dcc-js";
import GI18nCard from "~/components/App/Common/GI18nCard";
import DccLocalizedTextBlock from "~/components/App/Form/XML/DccLocalizedTextBlock";
import XmlTextField from "~/components/App/Form/XML/XmlTextField";
import GCol from "~/components/App/Common/GCol";
import RichContent from "~/components/DCC/Common/RichContent.vue";
import XmlCheckbox from "~/components/App/Form/XML/XmlCheckbox";
import GTextField from "~/components/App/Form/gTextField";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";
import { insertIf } from "~/assets/util/general";

export default {
  name: "Certificate",
  components: {
    GDropDownMenu,
    GTextField,
    XmlCheckbox,
    RichContent,
    GCol,
    XmlTextField,
    DccLocalizedTextBlock,
    GI18nCard,
  },
  props: {
    value: Object,
    card: {
      type: Boolean,
      default: true,
    },
    i18n: String,
    disabled: Boolean,
    level: String,
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "certificate",
    },
  },
  computed: {
    availableElements() {
      return ["richContentType"]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [...insertIf(this.value.description, "richContentType")];
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "richContentType":
          this.$set(this.value, "description", new RichContentType());
          break;
      }
    },
    deleteRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
  },
};
</script>
